<?php
error_reporting(E_ALL);
ini_set('display_errors',1);
	ob_start();
    session_start();
require_once("functions.php");

class Controller {
	private $databaseHost = "localhost";
	private $databaseUser = "oscotech_oscopt";
	private $databasePass = "oscopt";
	private $databaseName = "oscotech_portal";	
	private $connection = false;
	private $result = array();
    private $myQuery = "";
    private $numResults = "";	
	public function __construct() {
		self::connect();
		
	
	}
	private function connect(){
		if(!$this->connection){
			$this->connection =new mysqli ($this->databaseHost,$this->databaseUser,$this->databasePass, $this->databaseName);
           // @mysqli_set_charset($this->connection,'utf8');
            if($this->connection){
           
                    //echo "<h1>Error in connection</h1>";
            //     }  
            }else{
            	array_push($this->result,mysql_error());
                return false; 
            }  
        }else{  
            return true;
        }  	
	}		
	public function get($table, $rows = '*', $join = null, $where = null, $order = null, $limit = null){
		$selectQuery = 'SELECT '.$rows.' FROM '.$table;
		if($join != null){
			$selectQuery .= ' JOIN '.$join;
		}
        if($where != null){
        	$selectQuery .= ' WHERE '.$where;
		}
        if($order != null){
            $selectQuery .= ' ORDER BY '.$order;
		}
        if($limit != null){
            $selectQuery .= ' LIMIT '.$limit;
        }
        $this->myQuery = $selectQuery;
		if($this->checkTable($table)){
        	$query = $this->connection->query($selectQuery);
			if($query){
				$this->numResults = mysqli_num_rows($query);
				for($row = 0; $row < $this->numResults; $row++){
					$result = mysqli_fetch_array($query);
                	$keys = array_keys($result);
                	for($key = 0; $key < count($keys); $key++){
                		if(!is_int($keys[$key])){
                    		if(mysqli_num_rows($query) >= 1){
                    			$this->result[$row][$keys[$key]] = $result[$keys[$key]];
							}else{
								$this->result = null;
							}
						}
					}
					
					
					
				}
				return true;
			}else{
				array_push($this->result,mysqli_error($this->connection));
				return false;
			}
      	}else{
      		return false;
    	}
    }	
	public function insert($table,$params=array()){
    	if($this->checkTable($table)){
    	 	$sqlQuery='INSERT INTO '.$table.' ('.implode(', ',array_keys($params)).') VALUES ("' . implode('", "', $params) . '")';
            $this->myQuery = $sqlQuery;
            if($ins = $this->connection->query($sqlQuery)){
            	array_push($this->result,mysqli_insert_id($this->connection));
                return true;
            }else{
            	array_push($this->result,mysqli_error());
                return false;
            }
        } else {
        	return false;
        }
    }	
	public function update($table,$params=array(),$where){
    	if($this->checkTable($table)){
    		$args=array();
			foreach($params as $field=>$value){
				$args[]=$field.'="'.$value.'"';
			}
			$sqlQuery='UPDATE '.$table.' SET '.implode(',',$args).' WHERE '.$where;
			$this->myQuery = $sqlQuery;
            if($query = $this->connection->query($sqlQuery)){
            	array_push($this->result,mysqli_affected_rows());
            	return true;
            }else{
            	array_push($this->result,mysqli_error($this->connection));
                return false;
            }
        }else{
            return false;
        }
    }
	public function delete($table,$where = null){
    	if($this->checkTable($table)){
    	 	if($where == null){
                $deleteQuery = 'DROP TABLE '.$table;
            }else{
                $deleteQuery = 'DELETE FROM '.$table.' WHERE '.$where;
            }
            if($del = $this->connection->query($deleteQuery)){
            	array_push($this->result,mysqli_affected_rows());
                $this->myQuery = $deleteQuery; 
                return true;
            }else{
            	array_push($this->result,mysqli_error($this->connection));
               	return false; 
            }
        }else{
            return false;
        }
    }
	private function checkTable($table){
		$tableExist = $this->connection->query('SHOW TABLES FROM '.$this->databaseName.' LIKE "'.$table.'"');
        if($tableExist){
        	if(mysqli_num_rows($tableExist)==1){
                return true;
            }else{
            	array_push($this->result,$table." does not exist in this database");
                return false;
            }
        }
    }
    public function getResult(){
        $value = $this->result;
        $this->result = array();
        return $value;
    }    
    public function escapeString($data){
        return mysqli_real_escape_string($this->connection, $data);
    }
	public function check_empty($data, $fields) {
		$msg = null;
		foreach ($fields as $value) {
			if (empty($data[$value])) {
				$msg .= "$value field empty <br />";
			}
		} 
		return $msg;
	}
} 
